#! /bin/bash
# Make extra /dev nodes.
# Copyright (C) 2004 Greg Kroah-Hartman <greg@kroah.com>
# Released under the GPL v2 only.
# Enhanced for Slackware Linux by volkerdi@slackware.com.
if [ -z $udev_root ]; then
. /etc/udev/udev.conf
fi
ln -snf /proc/self/fd $udev_root/fd
ln -snf /proc/self/fd/0 $udev_root/stdin
ln -snf /proc/self/fd/1 $udev_root/stdout
ln -snf /proc/self/fd/2 $udev_root/stderr
ln -snf /proc/kcore $udev_root/core
if [ -r $udev_root/psaux ]; then
( cd $udev_root ; ln -sf psaux mouse )
fi
mkdir -p $udev_root/pts $udev_root/shm
cd_num=0
dvd_num=0
if /bin/ls -l /dev | grep -q '^cdrom$' ; then
( cd $udev_root
/bin/ls -l * | grep '^cdrom$' | cut -f 2 -d : | cut -f 2 -d ' ' | while read optical_device ; do
if [ "$cd_num" = "0" ]; then
ln -sf $optical_device cdrom
ln -sf $optical_device cdrom0
else
ln -sf $optical_device cdrom${cd_num}
fi
cd_num=$(($cd_num + 1))
if grep -iq dvd /proc/ide/$optical_device/model ; then
if [ "$dvd_num" = "0" ]; then
ln -sf $optical_device dvd
ln -sf $optical_device dvd0
else
ln -sf $optical_device dvd${dvd_num}
fi
dvd_num=$(($dvd_num + 1))
fi
done
unset optical_device
)
fi
unset cd_num
unset dvd_num
if [ ! -r /dev/ppp ]; then
mknod -m 660 /dev/ppp c 108 0
chown root:uucp /dev/ppp
fi
mknod -m 660 /dev/nvidiactl c 195 255
mknod -m 660 /dev/nvidia0 c 195 0
mknod -m 660 /dev/nvidia1 c 195 1
chown root:video /dev/nvidia*
if [ ! -r /dev/loop0 ]; then
mknod -m 660 /dev/loop0 b 7 0
chown root:disk /dev/loop0
fi
if [ ! -r /dev/fd0 ]; then
mknod -m 660 /dev/fd0 b 2 0
mknod -m 660 /dev/fd1 b 2 1
mknod -m 660 /dev/fd2 b 2 2
mknod -m 660 /dev/fd3 b 2 3
chown root:floppy /dev/fd{0,1,2,3}
fi
if [ ! -r /dev/rtc ]; then
mknod -m 664 /dev/rtc c 10 135
fi
if [ ! -r /dev/vmmon ]; then
mknod -m 660 /dev/vmmon c 10 165
fi
if [ ! -r /dev/vmnet0 ]; then
mknod -m 660 /dev/vmnet0 c 119 0
for vmdev in 1 2 3 4 5 6 7 8 9 ; do
if [ ! -r /dev/vmnet${vmdev} ]; then
mknod -m 660 /dev/vmnet${vmdev} c 119 ${vmdev}
fi
done
unset vmdev
fi
