#!/bin/sh

INITRD_SIZE=12288

syslinux_config() {
  cat << EOF
default vmlinuz initrd=initrd load_ramdisk=1 prompt_ramdisk=0 ramdisk_size=$INITRD_SIZE load_ramdisk=1 rw root=/dev/ram
prompt 1
display message.txt
label linux
kernel vmlinuz
append initrd=initrd load_ramdisk=1 prompt_ramdisk=0 ramdisk_size=$INITRD_SIZE load_ramdisk=1 rw root=/dev/ram
EOF
}

# disk1_lzma -> disk1/libs.tar.lzma
( cd disk1_lzma && tar cf - . | lzma -6 > ../disk1/libs.tar.lzma )

# floppy1.initrd.gz
dd if=/dev/zero of=floppy1.initrd bs=1k count=$INITRD_SIZE
mke2fs -F -m 0 floppy1.initrd
mount -t ext2 -o loop floppy1.initrd /mnt/hd
( cd disk1 && cp -a . /mnt/hd )
umount /mnt/hd
7za a -tgzip floppy1.initrd.gz floppy1.initrd
mv floppy1.initrd.gz initrd

# floppy1.img
dd if=/dev/zero of=floppy1.img bs=1k count=1440
mkdosfs -f 1 -F 12 -r 16 -R 1 floppy1.img
syslinux floppy1.img
mount -t msdos -o loop floppy1.img /mnt/hd
cp message.txt vmlinuz initrd /mnt/hd
syslinux_config > /mnt/hd/syslinux.cfg
umount /mnt/hd

# floppy2.img & floppy3.img
#( cd disk2 && tar-1.13 cf - -b1 . | lzma -6 > ../floppy2.img )
#( cd disk3 && tar-1.13 cf - -b1 . | lzma -6 > ../floppy3.img )

# netinst.iso
mount -t ext2 -o loop floppy1.initrd /mnt/hd
( cd /mnt/hd && lzcat libs.tar.lzma | tar-1.13 xf - -b1 && rm -f libs.tar.lzma )
( cd disk2 && cp -a . /mnt/hd )
( cd disk3 && cp -a . /mnt/hd )
umount /mnt/hd
7za a -tgzip floppy1.initrd.gz floppy1.initrd
rm -f floppy1.initrd
rm -rf isodir
mkdir isodir
mv floppy1.initrd.gz isodir/initrd
cp -p /usr/share/syslinux/isolinux.bin isodir
cp message.txt vmlinuz isodir
syslinux_config > isodir/isolinux.cfg
rm -f netinst.iso
mkisofs \
  -o netinst.iso \
  -b isolinux/isolinux.bin \
  -c isolinux/boot.cat \
  -no-emul-boot \
  -boot-load-size 4 \
  -boot-info-table \
  -graft-points \
  isolinux/=isodir
